/*
 * Copyright (c) 2002 Falk Feddersen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


/*    
      sediment.h  - sediment  module to turbulence model 
*/

/* just a test comment added */

#ifndef SEDIMENT_H
#define SEDIMENT_H

#include "defs.h"


typedef struct {
  switch_t sediment_flag;
  bc_t sediment_bc;
  double D50;
} sedimentinfo;


void calculate_sediment_stats(field1D *KSV);

//void rhs_sediment_eq(field1D *ST, const field1D *S, const field1D *Kv);

void rhs_implicit_sediment_eq(field1D *ST, const field1D *S, const field1D *Kv);

void implicit_solve_sediment_euler(field1D *S, const field1D *ST, const field1D *Kv, double dt);

void implicit_solve_sedimentAB2(field1D *S, const field1D *ST1, const field1D *ST2, const field1D *Kv, double dt);

//void update_sediment_bc(field1D *S, const field1D *Kv);

//void update_sediment_AB2(field1D *S, const field1D *ST1, const field1D *ST2, double dt);

//void update_sediment_euler(field1D *S, const field1D *ST, double dt);

void calculate_sediment_fluxes(field1D *SFX, field1D *SFY);

void deallocate_sediment_variables();

void allocate_sediment_variables(int nz, sedimentinfo *S);

#endif /* SEDIMENT_H */
